#!/bin/bash
cd files

yes_no(){
	YESNOARG="$1"
	echo "$YESNOARG"
        read -p "Type Y to continue or N to break. [Y/N]:" YO
	[ "$YO" != "N" -a "$YO" != "Y" -a "$YO" != "y" -a "$YO" != "n" ] && \
	yes_no 
        [ "$YO" = "N" -o "$YO" = "n" ] && return 1
        [ "$YO" = "Y" -o "$YO" = "y" ] && return 0
}

check_stuff(){
echo "################ Checking needed stuff ################"
for i in adb gpsd netstat; do
	RESULT=`which $i`
	printf "Checking $i "
	if [ -z "$RESULT" ]; then
	echo "- NOT FOUND
Install $i or, if You have it in place not set in default environement
set full path in /usr/local/bin/adb_gps_usb.sh Definitions section"
	yes_no || exit 1
	else
	echo "- found as $RESULT - ##OK##"
	fi
done
echo "######################################################"
}

check_id(){
echo "############### Checking phone model #################"
echo "
Unplug your phone and press [Enter]"
read YO
#echo 
udevadm monitor -p --subsystem-match=usb | grep -m 1 PRODUCT= > MODEL.tmp & 
echo "Now plug it back, wait about 10 seconds then press [Enter]"
read YO
killall udevadm 2>&1
#clear
TMP=$(awk -F "[=/]" '{printf("0x%s", $2)}' MODEL.tmp)
VENDOR=$(printf "%04x" $TMP)
TMP=$(awk -F "[=/]" '{printf("0x%s", $3)}' MODEL.tmp)
PRODUCT=$(printf "%04x" $TMP)
#VENDOR=$(awk -F "[=/]" '{printf("%04x", $2)}' MODEL.tmp)
#PRODUCT=$(awk -F "[=/]" '{printf("%04x", $3)}' MODEL.tmp)
if [ -z "$VENDOR" ] || [ -z "$PRODUCT" ]; then
    echo "No phone found - Exiting..."
    echo ""
    rm -f MODEL.tmp
    exit
fi
lsusb -v -d $VENDOR:$PRODUCT | grep 'iSerial\|iProduct\|iManufacturer' > PhoneInfo.tmp
MFG=$(grep 'iManufacturer' PhoneInfo.tmp | awk '{print $3}')
PRO=$(grep 'iProduct' PhoneInfo.tmp | awk '{print $3}')
SN=$(grep 'iSerial' PhoneInfo.tmp | awk '{print $3}')
echo " "
echo "Your phone information:"
echo "   Mfg - $MFG"
echo "   Product - $PRO"
echo "   Serial Number - $SN"
echo " "
answer1
echo "######################################################"
rm -f MODEL.tmp
rm -f PhoneInfo.tmp
}


installit(){
echo " "
echo "################# Installing stuff ####################"
echo " "
echo "A non-root user is required for adb on some systems"
read -p "Enter non-root user to use for adb: " USER
echo " "
echo "Setting as $PRO"
echo " "
echo "# udev rules for start shared android gps device" > 99-adb_gps_usb.rules
echo ACTION==\"add\", SUBSYSTEM==\"usb\", ATTRS{idVendor}==\"$VENDOR\", ATTRS{serial}==\"$SN\", SYMLINK+=\"adbmobile\", TAG+=\"systemd\", ENV{SYSTEMD_WANTS}+=\"adb-gps.service\" >> 99-adb_gps_usb.rules
echo "Copying files & setting udev, systemd"
cp 99-adb_gps_usb.rules /etc/udev/rules.d/99-adb_gps_usb.rules
cp adb_gps_usb.sh /usr/local/bin/
chmod 644 /etc/udev/rules.d/99-adb_gps_usb.rules
chmod 755 /usr/local/bin/adb_gps_usb.sh
chown root:root /usr/local/bin/adb_gps_usb.sh 
sed -i 's/USER=user/USER='$USER'/' /usr/local/bin/adb_gps_usb.sh
cp adb-gps.service /etc/systemd/system/
chown root:root /etc/systemd/system/adb-gps.service
systemctl daemon-reload
udevadm control --reload
udevadm trigger
echo " "
echo "#################### Done ############################"
exit 0
}

answer1(){
yes_no "Does this look right?" && installit
read -p "To check it again  type \"again\"; to break type anything else.: " AGAIN
[ "$AGAIN" = "again" ] &&  check_id || exit 1
}

[ `id -u` -ne 0 ] && echo "This script needs admin privileges
Login as root or use sudo command (# sudo ./install.sh)" && exit 1
check_stuff
check_id
echo "Bye" 
